/*
 * Copyright (c) 2006 The Massachusetts Institute of Technology. All rights reserved.
 * Please see license.txt in top level directory for full license.
 * 
 */
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
//
using System.Text;
using System.Security.Cryptography;
using Encryption;
using System.Text.RegularExpressions;
using System.Xml;
using System.IO; //StringReader

namespace PREPConfiguration
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnCreate;
		private System.Windows.Forms.Label label2;

		static RNGCryptoServiceProvider srng = new RNGCryptoServiceProvider();
		const int decryptionKeyLength = 24;
		const int validationKeyLength = 64;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TextBox txtDomain;
		private System.Windows.Forms.TextBox txtUser;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.TextBox txtSQL;
		private System.Windows.Forms.TextBox txtServerEmailFrom;
		private System.Windows.Forms.TextBox txtErrorEmailFrom;
		private System.Windows.Forms.TextBox txtErrorEmailTo;
		private System.Windows.Forms.ErrorProvider errorProvider1;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TextBox txtDocLibrary;
		private System.Windows.Forms.TextBox txtTaskList;
		private System.Windows.Forms.Button btnListNames;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Button btnDecode;
		private System.Windows.Forms.TextBox txtAppSettings;
		private System.Windows.Forms.Label label14;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.label1 = new System.Windows.Forms.Label();
			this.txtAppSettings = new System.Windows.Forms.TextBox();
			this.btnCreate = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.txtDomain = new System.Windows.Forms.TextBox();
			this.txtUser = new System.Windows.Forms.TextBox();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.txtSQL = new System.Windows.Forms.TextBox();
			this.txtServerEmailFrom = new System.Windows.Forms.TextBox();
			this.txtErrorEmailFrom = new System.Windows.Forms.TextBox();
			this.txtErrorEmailTo = new System.Windows.Forms.TextBox();
			this.errorProvider1 = new System.Windows.Forms.ErrorProvider();
			this.label10 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.txtDocLibrary = new System.Windows.Forms.TextBox();
			this.txtTaskList = new System.Windows.Forms.TextBox();
			this.btnListNames = new System.Windows.Forms.Button();
			this.label12 = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.btnDecode = new System.Windows.Forms.Button();
			this.label14 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(56, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(416, 32);
			this.label1.TabIndex = 0;
			this.label1.Text = "Create machine.config appSettings keys for PREP";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtAppSettings
			// 
			this.txtAppSettings.BackColor = System.Drawing.SystemColors.HighlightText;
			this.txtAppSettings.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtAppSettings.Location = new System.Drawing.Point(24, 376);
			this.txtAppSettings.Multiline = true;
			this.txtAppSettings.Name = "txtAppSettings";
			this.txtAppSettings.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtAppSettings.Size = new System.Drawing.Size(464, 56);
			this.txtAppSettings.TabIndex = 1;
			this.txtAppSettings.Text = "";
			// 
			// btnCreate
			// 
			this.btnCreate.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnCreate.Location = new System.Drawing.Point(24, 512);
			this.btnCreate.Name = "btnCreate";
			this.btnCreate.Size = new System.Drawing.Size(144, 32);
			this.btnCreate.TabIndex = 2;
			this.btnCreate.Text = "Create";
			this.btnCreate.Click += new System.EventHandler(this.btnCreate_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 448);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(272, 40);
			this.label2.TabIndex = 3;
			this.label2.Text = "Click the Create button, then copy the new appSettings to the clipboard. Then add" +
				" these values to the <appSettings> section of machine.config.";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 88);
			this.label3.Name = "label3";
			this.label3.TabIndex = 4;
			this.label3.Text = "User Name";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(24, 56);
			this.label4.Name = "label4";
			this.label4.TabIndex = 5;
			this.label4.Text = "Domain Name";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(24, 120);
			this.label5.Name = "label5";
			this.label5.TabIndex = 6;
			this.label5.Text = "Password";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(24, 288);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(144, 29);
			this.label6.TabIndex = 7;
			this.label6.Text = "Error Email From Address";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(24, 248);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(144, 29);
			this.label7.TabIndex = 8;
			this.label7.Text = "Server Email From Address";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(24, 328);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(152, 29);
			this.label8.TabIndex = 9;
			this.label8.Text = "Error Email To Address";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(24, 152);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(144, 29);
			this.label9.TabIndex = 10;
			this.label9.Text = "SQL Connection String";
			// 
			// txtDomain
			// 
			this.txtDomain.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.txtDomain.Location = new System.Drawing.Point(136, 56);
			this.txtDomain.Name = "txtDomain";
			this.txtDomain.Size = new System.Drawing.Size(104, 20);
			this.txtDomain.TabIndex = 11;
			this.txtDomain.Text = "";
			this.txtDomain.Validating += new System.ComponentModel.CancelEventHandler(this.txtDomain_Validating);
			// 
			// txtUser
			// 
			this.txtUser.Location = new System.Drawing.Point(136, 88);
			this.txtUser.Name = "txtUser";
			this.txtUser.Size = new System.Drawing.Size(104, 20);
			this.txtUser.TabIndex = 12;
			this.txtUser.Text = "";
			this.txtUser.Validating += new System.ComponentModel.CancelEventHandler(this.txtUser_Validating);
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(136, 120);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.Size = new System.Drawing.Size(200, 20);
			this.txtPassword.TabIndex = 13;
			this.txtPassword.Text = "";
			this.txtPassword.Validating += new System.ComponentModel.CancelEventHandler(this.txtPassword_Validating);
			// 
			// txtSQL
			// 
			this.txtSQL.Location = new System.Drawing.Point(176, 152);
			this.txtSQL.Name = "txtSQL";
			this.txtSQL.Size = new System.Drawing.Size(312, 20);
			this.txtSQL.TabIndex = 14;
			this.txtSQL.Text = "";
			this.txtSQL.Validating += new System.ComponentModel.CancelEventHandler(this.txtSQL_Validating);
			// 
			// txtServerEmailFrom
			// 
			this.txtServerEmailFrom.Location = new System.Drawing.Point(176, 248);
			this.txtServerEmailFrom.Name = "txtServerEmailFrom";
			this.txtServerEmailFrom.Size = new System.Drawing.Size(160, 20);
			this.txtServerEmailFrom.TabIndex = 15;
			this.txtServerEmailFrom.Text = "";
			this.txtServerEmailFrom.Validating += new System.ComponentModel.CancelEventHandler(this.txtServerEmailFrom_Validating);
			// 
			// txtErrorEmailFrom
			// 
			this.txtErrorEmailFrom.Location = new System.Drawing.Point(176, 288);
			this.txtErrorEmailFrom.Name = "txtErrorEmailFrom";
			this.txtErrorEmailFrom.Size = new System.Drawing.Size(160, 20);
			this.txtErrorEmailFrom.TabIndex = 16;
			this.txtErrorEmailFrom.Text = "";
			this.txtErrorEmailFrom.Validating += new System.ComponentModel.CancelEventHandler(this.txtErrorEmailFrom_Validating);
			// 
			// txtErrorEmailTo
			// 
			this.txtErrorEmailTo.Location = new System.Drawing.Point(176, 328);
			this.txtErrorEmailTo.Name = "txtErrorEmailTo";
			this.txtErrorEmailTo.Size = new System.Drawing.Size(160, 20);
			this.txtErrorEmailTo.TabIndex = 17;
			this.txtErrorEmailTo.Text = "";
			this.txtErrorEmailTo.Validating += new System.ComponentModel.CancelEventHandler(this.txtErrorEmailTo_Validating);
			// 
			// errorProvider1
			// 
			this.errorProvider1.ContainerControl = this;
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(24, 184);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(136, 24);
			this.label10.TabIndex = 18;
			this.label10.Text = "PREP Document Library";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(24, 216);
			this.label11.Name = "label11";
			this.label11.TabIndex = 19;
			this.label11.Text = "PREP Task List";
			// 
			// txtDocLibrary
			// 
			this.txtDocLibrary.Location = new System.Drawing.Point(176, 184);
			this.txtDocLibrary.Name = "txtDocLibrary";
			this.txtDocLibrary.ReadOnly = true;
			this.txtDocLibrary.Size = new System.Drawing.Size(160, 20);
			this.txtDocLibrary.TabIndex = 20;
			this.txtDocLibrary.Text = "PREP Documents";
			// 
			// txtTaskList
			// 
			this.txtTaskList.Location = new System.Drawing.Point(176, 216);
			this.txtTaskList.Name = "txtTaskList";
			this.txtTaskList.ReadOnly = true;
			this.txtTaskList.Size = new System.Drawing.Size(160, 20);
			this.txtTaskList.TabIndex = 21;
			this.txtTaskList.Text = "PREP Review Tasks";
			// 
			// btnListNames
			// 
			this.btnListNames.Location = new System.Drawing.Point(352, 216);
			this.btnListNames.Name = "btnListNames";
			this.btnListNames.Size = new System.Drawing.Size(72, 23);
			this.btnListNames.TabIndex = 22;
			this.btnListNames.Text = "Edit";
			this.btnListNames.Click += new System.EventHandler(this.btnListNames_Click);
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(352, 184);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(136, 24);
			this.label12.TabIndex = 23;
			this.label12.Text = "Ordinarily you should not change these";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(304, 448);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(184, 56);
			this.label13.TabIndex = 25;
			this.label13.Text = "Or paste in an existing section and click Decode. Do not include the <appSettings" +
				"> tags, only the <add key=... tags.";
			// 
			// btnDecode
			// 
			this.btnDecode.Location = new System.Drawing.Point(328, 512);
			this.btnDecode.Name = "btnDecode";
			this.btnDecode.Size = new System.Drawing.Size(136, 32);
			this.btnDecode.TabIndex = 26;
			this.btnDecode.Text = "Decode";
			this.btnDecode.Click += new System.EventHandler(this.btnDecode_Click);
			// 
			// label14
			// 
			this.label14.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label14.Location = new System.Drawing.Point(280, 56);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(216, 48);
			this.label14.TabIndex = 27;
			this.label14.Text = "DO NOT LEAVE THIS APPLICATION ON A PRODUCTION MACHINE.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 581);
			this.Controls.Add(this.label14);
			this.Controls.Add(this.btnDecode);
			this.Controls.Add(this.label13);
			this.Controls.Add(this.label12);
			this.Controls.Add(this.btnListNames);
			this.Controls.Add(this.txtTaskList);
			this.Controls.Add(this.txtDocLibrary);
			this.Controls.Add(this.label11);
			this.Controls.Add(this.label10);
			this.Controls.Add(this.txtErrorEmailTo);
			this.Controls.Add(this.txtErrorEmailFrom);
			this.Controls.Add(this.txtServerEmailFrom);
			this.Controls.Add(this.txtSQL);
			this.Controls.Add(this.txtPassword);
			this.Controls.Add(this.txtUser);
			this.Controls.Add(this.txtDomain);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.btnCreate);
			this.Controls.Add(this.txtAppSettings);
			this.Controls.Add(this.label1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "PREP Configuration";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnCreate_Click(object sender, System.EventArgs e)
		{
			// Make sure each text box has been validated
			foreach( Control control in Controls )
			{
				control.Focus();
				// Validate causes the control's Validating event to be
				// fired if .CausesValidation property is true
				if( !this.Validate() )
				{
					DialogResult = DialogResult.None;
					return;
				}
			}
			
			txtAppSettings.Text = GenerateKey();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// Create and populate a menu
			
			MainMenu menu = new MainMenu();

			MenuItem filemenu = new MenuItem();
			filemenu.Text = "&File";
			menu.MenuItems.Add(filemenu);
			MenuItem open = new MenuItem();
			
			MenuItem exit= new MenuItem();
			exit.Text = "E&xit";
			exit.Click += new EventHandler(MenuHandler);
			filemenu.MenuItems.Add(exit);

			MenuItem editmenu = new MenuItem();
			editmenu.Text = "&Edit";
			menu.MenuItems.Add(editmenu);

			MenuItem copy = new MenuItem();
			copy.Text = "&Copy";
			copy.Click += new EventHandler(MenuHandler);
			editmenu.MenuItems.Add(copy);

			this.Menu = menu;

		}

		void MenuHandler(Object Sender,EventArgs e)
		{
			MenuItem item=(MenuItem)Sender;
			switch(item.Text)
			{
				case "E&xit":
					Close();
					break;
				case "&Copy":
					txtAppSettings.Focus();
					txtAppSettings.SelectAll();
					txtAppSettings.Copy();
					break;
			}
		}

		/// <summary>
		/// Generates text of the machine key tag in the machine.config
		/// </summary>
		/// <returns>text to paste into machine.config</returns>
		string GenerateKey()
		{ 
			 
			string machineKey = writeKeyAsHexDigits(getRandom(validationKeyLength));
			string sKey = machineKey.Substring(8, 24);
			string sIV = machineKey.Substring(64, 8);

			string domain = txtDomain.Text.Trim(); //Encrypt(txtDomain.Text.Trim(), sKey, sIV);
			string userName = Encrypt(txtUser.Text.Trim(), sKey, sIV);
			string password = Encrypt(txtPassword.Text.Trim(), sKey, sIV);
			string connection = Encrypt(txtSQL.Text.Trim(), sKey, sIV);
			
			StringBuilder sb = new StringBuilder();
			sb.Append("<add key=\"PREPWorkflow.MachineKey\" value=\"" + machineKey + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.Domain\" value=\"" + domain + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.Username\" value=\"" + userName + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.Password\" value=\"" + password + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.Connection\" value=\"" + connection + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.DocLibrary\" value=\"" + txtDocLibrary.Text.Trim() + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.TaskList\" value=\"" + txtTaskList.Text.Trim() + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.ImagePath\" value=\"/_layouts/PREPImages/\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.ServerEmailFrom\" value=\"" + txtServerEmailFrom.Text.Trim() + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.ErrorEmailFrom\" value=\"" + txtErrorEmailFrom.Text.Trim() + "\" />" + Environment.NewLine);
			sb.Append("<add key=\"PREPWorkflow.ErrorEmailTo\" value=\"" + txtErrorEmailTo.Text.Trim() + "\" />" + Environment.NewLine);

			return sb.ToString();
		}

		/// <summary>
		/// retrieve a random byte array of cb size
		/// </summary>
		/// <param name="cb">size of array to return</param>
		/// <returns>byte array of cb size with random values</returns>
		byte[] getRandom(int cb) 
		{
			byte[] randomData = new byte[cb];
			srng.GetBytes(randomData);
			return randomData;
		}
		/// <summary>
		/// produce a string of hex code from a byte array
		/// </summary>
		/// <param name="key">byte array to turn into a hex string</param>
		/// <returns>hex string representation of key</returns>
		string writeKeyAsHexDigits(byte[] key) 
		{
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < key.Length; ++i) 
			{
					 
				sb.Append(	String.Format("{0:X2}", key[i]));
					 
			}
			return sb.ToString();
		}

		/// <summary>
		/// Encrypts plainTextToEncrypt
		/// </summary>
		/// <param name="plainTextToEncrypt">text to encrypt</param>
		/// <returns>base 64 string of cipher text</returns>
		string Encrypt(string plainTextToEncrypt, string sKey, string sIV)
		{
			// Hold the cypher text
			byte[] cipherText = null;

			//string sKeyForCrypt = ConfigurationSettings.ge

			byte[] keyForCrypt = Encoding.ASCII.GetBytes(sKey);
			byte[] IV = Encoding.ASCII.GetBytes(sIV);
            
			try
			{	//Try to encrypt.
				//Create the encryptor.
				Encryptor enc = new Encryptor(EncryptionAlgorithm.TripleDes);
				byte[] plainText = Encoding.ASCII.GetBytes(plainTextToEncrypt);
				enc.IV = IV;

				// Perform the encryption.
				cipherText = enc.Encrypt(plainText, keyForCrypt);
			}
			catch(Exception ex)
			{
				throw new Exception("Exception encrypting. " + ex.Message);
                
			}
			return Convert.ToBase64String(cipherText);
		}

		/// <summary>
		/// Decrypts cipherText
		/// </summary>
		/// <param name="cipherText">base 64 string of cipher text to decode</param>
		/// <returns>the original string unencrypted</returns>
		string Decrypt(string cipherText, string sKey, string sIV)
		{
			byte[] plainText =null;

			byte[] keyForCrypt = Encoding.ASCII.GetBytes(sKey);
			byte[] IV = Encoding.ASCII.GetBytes(sIV);
			try
			{
				// Set up the Decryptor object
				Decryptor dec = new Decryptor(EncryptionAlgorithm.TripleDes);

				// Set the Initialization Vector
				dec.IV = IV;

				// Perform the decryption
				plainText =  dec.Decrypt(Convert.FromBase64String(cipherText), keyForCrypt);
			}
			catch(Exception ex)
			{
				throw new Exception("Error decrypting ciphertext", ex);
			}
            
			return Encoding.ASCII.GetString(plainText);
		}

		private void txtDomain_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			string error = null;
			if( txtDomain.Text.Length == 0 ) 
			{
				error = "Please enter a Domain";
				e.Cancel = true;
			}

			// Don't allow embedded spaces
			Regex r = new Regex(@"^[^ ]*$", RegexOptions.Compiled);
			if (! r.IsMatch(txtDomain.Text))
			{
				error = "Domain name cannot contain spaces";
				e.Cancel = true;
			}

			// 1st char must be alphanumeric
			r = new Regex(@"^[a-zA-Z0-9]", RegexOptions.Compiled);
			if (! r.IsMatch(txtDomain.Text))
			{
				error = "First character must be a letter or a Number";
				e.Cancel = true;
			}

			// Last char must be alphanumeric
			r = new Regex(@"[a-zA-Z0-9]$", RegexOptions.Compiled);
			if (! r.IsMatch(txtDomain.Text))
			{
				error = "Last character must be a letter or a Number";
				e.Cancel = true;
			}

			errorProvider1.SetError((Control)sender, error);

		}

		private void txtUser_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			string error = null;
			if( txtUser.Text.Length == 0 ) 
			{
				error = "Please enter a User Name";
				e.Cancel = true;
			}

			errorProvider1.SetError((Control)sender, error);
		}

		private void txtPassword_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			string error = null;
			if( txtPassword.Text.Length == 0 ) 
			{
				error = "Please enter a Password";
				e.Cancel = true;
			}
			errorProvider1.SetError((Control)sender, error);
		}

		private void txtSQL_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			string error = null;
			if( txtSQL.Text.Length == 0 ) 
			{
				error = "Please enter a SQL Connection String. Please insure that this connection string works before entering it.";
				e.Cancel = true;
			}
			errorProvider1.SetError((Control)sender, error);
		}

		private void txtServerEmailFrom_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			string error = null;
			if( txtServerEmailFrom.Text.Length == 0 ) 
			{
				error = "Please enter a Server email \"from\" address. This is the \"from\" address for server-based communications to users.";
				e.Cancel = true;
			}

			// check email
			Regex r = new Regex(@"^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$", RegexOptions.Compiled);
			if (! r.IsMatch(txtServerEmailFrom.Text))
			{
				error = "Not a valid email address";
				e.Cancel = true;
			}

			errorProvider1.SetError((Control)sender, error);
		}

		private void txtErrorEmailFrom_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			string error = null;
			if( txtErrorEmailFrom.Text.Length == 0 ) 
			{
				error = "Please enter an Error email \"from\" address. This is the \"from\" address for messages containing reports of exceptions thrown by the application.";
				e.Cancel = true;
			}

			// check email
			Regex r = new Regex(@"^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$", RegexOptions.Compiled);
			if (! r.IsMatch(txtErrorEmailFrom.Text))
			{
				error = "Not a valid email address";
				e.Cancel = true;
			}

			errorProvider1.SetError((Control)sender, error);
		}

		private void txtErrorEmailTo_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			string error = null;
			if( txtErrorEmailTo.Text.Length == 0 ) 
			{
				error = "Please enter an Error email \"to\" address. This is the address which will receive reports of exceptions thrown by the application.";
				e.Cancel = true;
			}

			// check email
			Regex r = new Regex(@"^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$", RegexOptions.Compiled);
			if (! r.IsMatch(txtErrorEmailTo.Text))
			{
				error = "Not a valid email address";
				e.Cancel = true;
			}

			errorProvider1.SetError((Control)sender, error);
		}

		private void btnListNames_Click(object sender, System.EventArgs e)
		{
			if(txtDocLibrary.ReadOnly == true)
				txtDocLibrary.ReadOnly = false;
			else	
				txtDocLibrary.ReadOnly = true;

			if(txtTaskList.ReadOnly == true)
				txtTaskList.ReadOnly = false;
			else
				txtTaskList.ReadOnly = true;

		}

		private void btnDecode_Click(object sender, System.EventArgs e)
		{
			
			string machineKey = "";
			string _domain = "";
			string _userName = "";;
			string _password = "";;
			string _connection = "";;
			try
			{
				
				// Create an Xml document out of the text in the appSettings text box.
				XmlDocument cfgDoc = new XmlDocument();
				cfgDoc.LoadXml("<configuration>" + txtAppSettings.Text + "</configuration>");
				
				// Pull out the keys
				XmlNodeList _add = cfgDoc.GetElementsByTagName("add");
				foreach(XmlNode node in _add)
				{
					XmlAttributeCollection xac = node.Attributes;
					for(int i=0; i<xac.Count; i++)
					{
						// Encrypted values
						if(xac[i].InnerText == "PREPWorkflow.MachineKey")
						{
							machineKey = xac[i+1].InnerText;
						}
						if(xac[i].InnerText == "PREPWorkflow.Domain")
						{
							_domain = xac[i+1].InnerText;
						}
						if(xac[i].InnerText == "PREPWorkflow.Username")
						{
							_userName = xac[i+1].InnerText;
						}
						if(xac[i].InnerText == "PREPWorkflow.Password")
						{
							_password = xac[i+1].InnerText;
						}
						if(xac[i].InnerText == "PREPWorkflow.Connection")
						{
							_connection = xac[i+1].InnerText;
						}

						// Non-encrypted values
						if(xac[i].InnerText == "PREPWorkflow.DocLibrary")
						{
							txtDocLibrary.Text = xac[i+1].InnerText;
						}
						if(xac[i].InnerText == "PREPWorkflow.TaskList")
						{
							txtTaskList.Text = xac[i+1].InnerText;
						}
						if(xac[i].InnerText == "PREPWorkflow.ServerEmailFrom")
						{
							txtServerEmailFrom.Text = xac[i+1].InnerText;
						}
						if(xac[i].InnerText == "PREPWorkflow.ErrorEmailFrom")
						{
							txtErrorEmailFrom.Text = xac[i+1].InnerText;
						}
						if(xac[i].InnerText == "PREPWorkflow.ErrorEmailTo")
						{
							txtErrorEmailTo.Text = xac[i+1].InnerText;
						}

					}
				}

				// values within the machineKey will be used to decrypt the cipher text
				string sKey = machineKey.Substring(8, 24);
				string sIV = machineKey.Substring(64, 8);
					
				string domain = _domain; //Decrypt(_domain, sKey, sIV);
				string userName = Decrypt(_userName, sKey, sIV);
				string password = Decrypt(_password, sKey, sIV);
				string connection = Decrypt(_connection, sKey, sIV);

				StringBuilder result = new StringBuilder();
				//result.Append("Domain: " + domain + Environment.NewLine);
				result.Append("DECRYPTED STRINGS:" + Environment.NewLine);
				result.Append("Username: " + userName + Environment.NewLine); 
				result.Append("Password: " + password + Environment.NewLine);
				result.Append("Connection: " + connection + Environment.NewLine);

				txtAppSettings.Text = result.ToString();

				txtDomain.Text = domain;
				txtUser.Text = userName;
				txtPassword.Text = password;
				txtSQL.Text = connection;

			}
			catch (Exception ex)
			{
				txtAppSettings.Text = ex.ToString();
			}
	
		}

	}
}
